import { __decorate } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Component, NgModule } from '@angular/core';
import { trigger, state, style, transition, animate, animation, keyframes } from '@angular/animations';

let AnimationService = class AnimationService {
    constructor() { }
};
AnimationService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AnimationService_Factory() { return new AnimationService(); }, token: AnimationService, providedIn: "root" });
AnimationService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], AnimationService);

let AnimationComponent = class AnimationComponent {
    constructor() { }
    ngOnInit() {
    }
};
AnimationComponent = __decorate([
    Component({
        selector: 'lib-animation',
        template: `
    <p>
      animation works!
    </p>
  `
    })
], AnimationComponent);

let AnimationModule = class AnimationModule {
};
AnimationModule = __decorate([
    NgModule({
        declarations: [AnimationComponent],
        imports: [],
        exports: [AnimationComponent]
    })
], AnimationModule);

/**
 * @author Jafar Amini in March 2018.
 */
// Component transition animations
const slideInDownAnimation = trigger('slideInOut', [
    state('*', style({
        opacity: 1,
        transform: 'translateX(0)'
    })),
    transition(':enter', [
        style({
            opacity: 0,
            transform: 'translateX(-100%)'
        }),
        animate('0.6s ease-in')
    ]),
    transition(':leave', [
        animate('0.5s ease-out', style({
            opacity: 0,
            transform: 'translateY(100%)'
        }))
    ])
]);

function transformAxis(axis, name) {
    return function (letter) {
        return axis === 'x'
            ? `${name}({{ ${letter} }}, 0, 0)`
            : `${name}(0, {{ ${letter} }}, 0)`;
    };
}
const DEFAULT_TIMING = 1;

function fade(fromOpacity, toOpacity) {
    return function (axis) {
        const translate3d = transformAxis(axis, 'translate3d');
        return function (steps) {
            const params = Object.assign({
                timing: DEFAULT_TIMING,
                delay: 0,
                fromOpacity,
                toOpacity,
            }, steps);
            return animation(animate('{{ timing }}s {{ delay }}s', keyframes([
                style({
                    opacity: '{{ fromOpacity }}',
                    transform: translate3d('a'),
                    offset: 0,
                }),
                style({
                    opacity: '{{ toOpacity }}',
                    transform: translate3d('b'),
                    offset: 1,
                }),
            ])), { params });
        };
    };
}
const fadeInDirection = fade(0, 1);
const fadeInX = fadeInDirection('x');
const fadeInY = fadeInDirection('y');
const fadeIn = fadeInX({ a: 0, b: 0 });
const fadeInDown = fadeInY({ a: '-100%', b: 0 });
const fadeInUp = fadeInY({ a: '100%', b: 0 });
const fadeInLeft = fadeInX({ a: '-100%', b: 0 });
const fadeInRight = fadeInX({ a: '100%', b: 0 });
const fadeOutDirection = fade(1, 0);
const fadeOutX = fadeOutDirection('x');
const fadeOutY = fadeOutDirection('y');
const fadeOut = fadeOutX({ a: 0, b: 0 });
const fadeOutDown = fadeOutY({ a: '-100%', b: 0 });
const fadeOutUp = fadeOutY({ a: '100%', b: 0 });
const fadeOutLeft = fadeOutX({ a: '-100%', b: 0 });
const fadeOutRight = fadeOutX({ a: '100%', b: 0 });
const slideDirection = fade(1, 1);
const slideX = slideDirection('x');
const slideY = slideDirection('y');
const slideInUp = slideY({ a: '-100%', b: 0 });
const slideInDown = slideY({ a: '100%', b: 0 });
const slideInLeft = slideX({ a: '-100%', b: 0 });
const slideInRight = slideX({ a: '100%', b: 0 });
const slideOutUp = slideY({ a: 0, b: '-100%' });
const slideOutDown = slideY({ a: 0, b: '100%' });
const slideOutLeft = slideX({ a: 0, b: '-100%' });
const slideOutRight = slideX({ a: 0, b: '100%' });

/*
 * Public API Surface of animation
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AnimationComponent, AnimationModule, AnimationService, fadeIn, fadeInDown, fadeInLeft, fadeInRight, fadeInUp, fadeOut, fadeOutDown, fadeOutLeft, fadeOutRight, fadeOutUp, slideInDown, slideInDownAnimation, slideInLeft, slideInRight, slideInUp, slideOutDown, slideOutLeft, slideOutRight, slideOutUp };
//# sourceMappingURL=angular-boot-animation.js.map
