import { __decorate } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Component, NgModule } from '@angular/core';
import { trigger, state, style, transition, animate, animation, keyframes } from '@angular/animations';

var AnimationService = /** @class */ (function () {
    function AnimationService() {
    }
    AnimationService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AnimationService_Factory() { return new AnimationService(); }, token: AnimationService, providedIn: "root" });
    AnimationService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], AnimationService);
    return AnimationService;
}());

var AnimationComponent = /** @class */ (function () {
    function AnimationComponent() {
    }
    AnimationComponent.prototype.ngOnInit = function () {
    };
    AnimationComponent = __decorate([
        Component({
            selector: 'lib-animation',
            template: "\n    <p>\n      animation works!\n    </p>\n  "
        })
    ], AnimationComponent);
    return AnimationComponent;
}());

var AnimationModule = /** @class */ (function () {
    function AnimationModule() {
    }
    AnimationModule = __decorate([
        NgModule({
            declarations: [AnimationComponent],
            imports: [],
            exports: [AnimationComponent]
        })
    ], AnimationModule);
    return AnimationModule;
}());

/**
 * @author Jafar Amini in March 2018.
 */
// Component transition animations
var slideInDownAnimation = trigger('slideInOut', [
    state('*', style({
        opacity: 1,
        transform: 'translateX(0)'
    })),
    transition(':enter', [
        style({
            opacity: 0,
            transform: 'translateX(-100%)'
        }),
        animate('0.6s ease-in')
    ]),
    transition(':leave', [
        animate('0.5s ease-out', style({
            opacity: 0,
            transform: 'translateY(100%)'
        }))
    ])
]);

function transformAxis(axis, name) {
    return function (letter) {
        return axis === 'x'
            ? name + "({{ " + letter + " }}, 0, 0)"
            : name + "(0, {{ " + letter + " }}, 0)";
    };
}
var DEFAULT_TIMING = 1;

function fade(fromOpacity, toOpacity) {
    return function (axis) {
        var translate3d = transformAxis(axis, 'translate3d');
        return function (steps) {
            var params = Object.assign({
                timing: DEFAULT_TIMING,
                delay: 0,
                fromOpacity: fromOpacity,
                toOpacity: toOpacity,
            }, steps);
            return animation(animate('{{ timing }}s {{ delay }}s', keyframes([
                style({
                    opacity: '{{ fromOpacity }}',
                    transform: translate3d('a'),
                    offset: 0,
                }),
                style({
                    opacity: '{{ toOpacity }}',
                    transform: translate3d('b'),
                    offset: 1,
                }),
            ])), { params: params });
        };
    };
}
var fadeInDirection = fade(0, 1);
var fadeInX = fadeInDirection('x');
var fadeInY = fadeInDirection('y');
var fadeIn = fadeInX({ a: 0, b: 0 });
var fadeInDown = fadeInY({ a: '-100%', b: 0 });
var fadeInUp = fadeInY({ a: '100%', b: 0 });
var fadeInLeft = fadeInX({ a: '-100%', b: 0 });
var fadeInRight = fadeInX({ a: '100%', b: 0 });
var fadeOutDirection = fade(1, 0);
var fadeOutX = fadeOutDirection('x');
var fadeOutY = fadeOutDirection('y');
var fadeOut = fadeOutX({ a: 0, b: 0 });
var fadeOutDown = fadeOutY({ a: '-100%', b: 0 });
var fadeOutUp = fadeOutY({ a: '100%', b: 0 });
var fadeOutLeft = fadeOutX({ a: '-100%', b: 0 });
var fadeOutRight = fadeOutX({ a: '100%', b: 0 });
var slideDirection = fade(1, 1);
var slideX = slideDirection('x');
var slideY = slideDirection('y');
var slideInUp = slideY({ a: '-100%', b: 0 });
var slideInDown = slideY({ a: '100%', b: 0 });
var slideInLeft = slideX({ a: '-100%', b: 0 });
var slideInRight = slideX({ a: '100%', b: 0 });
var slideOutUp = slideY({ a: 0, b: '-100%' });
var slideOutDown = slideY({ a: 0, b: '100%' });
var slideOutLeft = slideX({ a: 0, b: '-100%' });
var slideOutRight = slideX({ a: 0, b: '100%' });

/*
 * Public API Surface of animation
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AnimationComponent, AnimationModule, AnimationService, fadeIn, fadeInDown, fadeInLeft, fadeInRight, fadeInUp, fadeOut, fadeOutDown, fadeOutLeft, fadeOutRight, fadeOutUp, slideInDown, slideInDownAnimation, slideInLeft, slideInRight, slideInUp, slideOutDown, slideOutLeft, slideOutRight, slideOutUp };
//# sourceMappingURL=angular-boot-animation.js.map
